"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var sort_object_keys_1 = __importDefault(require("sort-object-keys"));
var sort_order_1 = __importDefault(require("sort-order"));
var PRE_OR_POST_PREFIX = /^(pre|post)/;
// Sort alphabetically by script name excluding pre/post prefixes
function scriptName() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var _a = args.map(function (arg) { return arg.replace(PRE_OR_POST_PREFIX, ''); }), a = _a[0], b = _a[1];
    if (a !== b) {
        return a < b ? -1 : 1;
    }
    else {
        return 0;
    }
}
// Sort by pre, script, post
function prePostHooks(a, b) {
    if (a.startsWith('pre') || b.startsWith('post')) {
        return -1;
    }
    else if (a.startsWith('post') || b.startsWith('pre')) {
        return 1;
    }
    else {
        return 0;
    }
}
var order = sort_order_1["default"](scriptName, prePostHooks);
function sortScripts(scripts) {
    var keys = Object.keys(scripts || {});
    return keys.length === 0 ? {} : { scripts: sort_object_keys_1["default"](scripts, keys.sort(order)) };
}
exports["default"] = sortScripts;
